/**
 * Copy(?)Right! Pablo Virolainen (pablo@ipi.fi) 2008
 * 
 * See COPYING.LGPL (LGPL)
 * This is part of ginotify (0.1)
 */

#ifndef __G_INOTIFY_H__
#define __G_INOTIFY_H__

#include <glib/gtypes.h>

G_BEGIN_DECLS

#include <glib.h>
#include <sys/inotify.h>

typedef struct _GINotify	GINotify;

struct _GINotify
{
  /*< private >*/
  guint ref_count;

  gint fd;
  GIOChannel* channel;
  gint read_size;

  GTree* funcs;
};

typedef gboolean (*GINOTIFYFunc) (GINotify	*source,
				  gint		id,
				  guint		mask,
				  guint		cookie,
				  gchar*	name,
				  gpointer	data);
/**
 * Returns new GINotify
 * 
 */

GINotify* notify_new();

/**
 * Frees notify.
 *
 */
void notify_free(GINotify* notify);

/**
 * Adds callback for event in given mask.
 * returns id (cookie in callback). Used to remove callback.
 */
gint notify_add(GINotify	*notify,
		const char	*path,
		guint		mask,
		GINOTIFYFunc	function,
		gpointer	data);

/**
 * Remove callback specified by id.
 *
 */
gboolean notify_remove(GINotify	*notify,
		       gint id);

G_END_DECLS

#endif /* __G_INOTIFY_H__ */
