/**
 * Copy(?)Right! Pablo Virolainen (pablo@ipi.fi) 2008
 * 
 * See COPYING.GPL (GPL)
 * This is part of ginotify (0.1)
 */

#include <sys/types.h>
#include <stdio.h>
#include <glib.h>
#include <glib-object.h>
#include "ginotify.h"

const char* mask_to_str_tbl[15] = {
  "IN_ACCESS",
  "IN_MODIFY",
  "IN_ATTRIB",
  "IN_CLOSE_WRITE",
  "IN_CLOSE_NOWRITE",
  "IN_OPEN",
  "IN_MOVED_FROM",
  "IN_MOVED_TO",
  "IN_CREATE",
  "IN_DELETE",
  "IN_DELETE_SELF",
  "IN_MOVE_SELF",
  "IN_UNMOUNT",
  "IN_Q_OVERFLOW",
  "IN_IGNORED",
};

static
gboolean nfunc (GINotify * source,
		gint id, guint mask,
		guint cookie,
		gchar * name,
		gpointer data)
{
	int i;
	
	fprintf (stderr, "%s, %08x %08x\n", name, mask, cookie);
	
	for(i=0;i<15;i++) {
	  if ((mask&(1<<i))!=0) {
	    fprintf(stderr,"Mask bit %i %s\n",i,mask_to_str_tbl[i]);
	  }
	}

	return TRUE;
}

static
const gchar* _get_home()
{
	const char *homedir = g_getenv ("HOME");
	if (!homedir)
		homedir = g_get_home_dir ();
	
	return homedir;
}

int main (int argc, char **argv)
{
	GMainLoop *loop;
	GOptionContext *ctx;
	GError *error = NULL;
	GINotify *notify;
	GOptionEntry options[] = {
		{NULL}
	};

	/* Let's init glib type */
	g_type_init ();

	ctx = g_option_context_new ("Chatter");
	g_option_context_add_main_entries (ctx, options, "");
	g_option_context_parse (ctx, &argc, &argv, &error);
	g_option_context_free (ctx);


	loop = g_main_loop_new (NULL, FALSE);

	notify = notify_new ();

	notify_add (notify, _get_home(), IN_ALL_EVENTS, nfunc, NULL);

	g_main_loop_run (loop);
	/* Not reached */
	return 0;
}
